#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<vector<int> > g;
vector<bool> visited;
set<int> result;
vector<pair<int, int> > security;

void BFS() {
    queue<pair<int, int> > q;

    for (auto guard: security) {
        if (!visited[guard.first]) {
            q.emplace(guard.first, guard.second);
            visited[guard.first] = true;
            result.insert(guard.first);
        }
    }

    while (!q.empty()) {
        int currV = q.front().first;
        int h = q.front().second;
        q.pop();

        if (h > 0) {
            for (int u: g[currV]) {
                if (!visited[u]) {
                    visited[u] = true;
                    q.emplace(u, h - 1);
                    result.insert(u);
                }
            }
        }
    }
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 1);
    visited.resize(n + 1);
    security.resize(k);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < k; i++) {
        cin >> security[i].first >> security[i].second;
    }
    BFS();
    cout << result.size() << '\n';
    for (auto x: result) {
        cout << x << " ";
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int t = 1;
    // cin >> t;
    solve();
}
